#include <iostream>
#include <string>
#include <fstream>
#include <sstream>

//convert the input into hex
std::string hex_converter(char* data, int size){

  std::stringstream	 ss;
  //the size of the data is 4 ( int32 ) 
  for(int i =0; i<size; i++)
	  ss<< std::hex << (int)data[i];
  return ss.str();


}

std::string data_reader(std::ifstream& file, int size){
  char		data[size];
 
  file.read (data, size);
  return hex_converter(data, size);
}

std::string string_reader(std::ifstream& file){
  char		c;
  std::string	tempstr;

  while ((c = file.get()) != '\0') {
	tempstr += c;
   } 
  return tempstr;
}

int gcno_dumper(std::string filename){
  int 			size;
  int			length;
  std::stringstream	lengthStream;

  std::ifstream file (filename, std::ios::binary);
  std::ofstream dumpfile ( "gcno_dump.txt"); 
  
  size = sizeof(int);

  if (file.is_open()){
	  file.seekg (0, std::ios::beg);
	  
	  //
	  // READING MAGIC, VERSION, STAMP
	  //
          
	  //reading magic 

          dumpfile << "MAGIC    :  "<< data_reader (file, size) << std::endl;
 
	 //read version
	 // after reading the first 4 bytes,
	 // we know that the next int32 ( i.e 4bytes)
	 // is version
	 dumpfile <<"VERSION  :  "<< data_reader (file, size) <<std::endl; 
		 
	 //read stamp
	 //next 4 bytes is stamp
	 dumpfile<< "TIMESTAMP:  "<< data_reader(file, size) <<std::endl;

	 //
	 //READING RECORD
	 //A record has a int32: tag, int32: length, and variable amount of data
	 // 
	  
	 //read HEADER
	 //header: int32:tag  int32: length;
	 dumpfile<<"TAG      :  "<< data_reader(file, size) <<std::endl;

	 //length ;
	 //the int value of length is dumped
	 lengthStream << data_reader(file, size);
	 lengthStream >> std::hex >> length;
	 dumpfile<<"LENGTH   :  "<< length <<std::endl;

	 //
	 //READING NOTES
	 //
         dumpfile << std::endl << "READING NOTE RECORDS \n" << std::endl; 
	 
	 //note: unit function-graph
	 //unit: header int32:checksum string:source
	 dumpfile<<"UNIT TAG      :  "<< data_reader(file, size) <<std::endl;	 
	 dumpfile<<"UNIT LENGTH   :  "<< data_reader(file, size) <<std::endl;
	 dumpfile<<"UNIT CHECKSUM :  "<< data_reader(file, size) <<std::endl;

	 //reading unit string
	 //first 4 bytes (int32) of string contains the length
         dumpfile<<"SOURCE LENGTH :  "<< data_reader(file, size) <<std::endl;
	 dumpfile<<"SOURCE        :  "<< string_reader(file) << std::endl;

	 //function-graph : announce_function basic_blocks { arcs | lines }
	 //announce_function: header int32:ident int32:lineno_checksum
	 //                   int32:cfg_checksum string:name string: source
	 //                   int32:lineno
	 dumpfile<< "NAME LENGTH   :  "<< data_reader(file, size) << std::endl;
	 dumpfile<< "NAME          :  "<< string_reader(file) << std::endl;

	 return 1;

  }

}

int main(int argc, char** argv){
	gcno_dumper( argv[1]);

}
